Index: platform/a530/sub/100a/capt_seq.c
===================================================================
--- platform/a530/sub/100a/capt_seq.c	(Revision 727)
+++ platform/a530/sub/100a/capt_seq.c	(Arbeitskopie)
@@ -227,3 +227,412 @@
 
 	);
 }
+
+/***************************************************************************/
+
+void __attribute__((naked,noinline)) _task_ExpDrvTask(){
+ asm volatile(
+                 "STMFD   SP!, {R4-R8,LR}\n"
+                 "SUB     SP, SP, #0x14\n"
+                 "MOV     R7, SP\n"
+                 "B       loc_FFCE3DD0\n"
+ "loc_FFCE39E4:\n"
+                 "CMP     R2, #0x1F\n"
+                 "BNE     loc_FFCE39FC\n"
+                 "LDR     R0, [R12,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x4C]\n"
+                 "B       loc_FFCE3A5C\n"
+ "loc_FFCE39FC:\n"
+                 "CMP     R2, #0x1A\n"
+                 "BNE     loc_FFCE3A10\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_FFCE3904\n"
+                 "B       loc_FFCE3A4C\n"
+ "loc_FFCE3A10:\n"
+                 "CMP     R2, #0x1B\n"
+                 "BNE     loc_FFCE3A24\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_FFCE3940\n"
+                 "B       loc_FFCE3A4C\n"
+ "loc_FFCE3A24:\n"
+                 "SUB     R3, R2, #0x1C\n"
+                 "CMP     R3, #1\n"
+                 "BHI     loc_FFCE3A3C\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_FFCE397C\n"
+                 "B       loc_FFCE3A4C\n"
+ "loc_FFCE3A3C:\n"
+                 "CMP     R2, #0x1E\n"
+                 "BNE     loc_FFCE3A68\n"
+                 "BL      sub_FFC97868\n"
+                 "BL      sub_FFC99658\n"
+ "loc_FFCE3A4C:\n"
+                 "LDR     R3, [SP]\n"
+                 "LDR     R0, [R3,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x4C]\n"
+ "loc_FFCE3A5C:\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE16C4\n"
+                 "B       loc_FFCE3DD0\n"
+ "loc_FFCE3A68:\n"
+                 "CMP     R2, #0xD\n"
+                 "MOV     R8, #1\n"
+                 "BNE     loc_FFCE3AD8\n"
+                 "LDR     R1, [R12,#0x40]\n"
+                 "ADD     R1, R1, R1,LSL#1\n"
+                 "ADD     R1, R12, R1,LSL#1\n"
+                 "ADD     R6, SP, #0xC\n"
+                 "SUB     R1, R1, #2\n"
+                 "MOV     R2, #6\n"
+                 "MOV     R0, R6\n"
+                 "BL      sub_FFEC3588\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE2B94\n"
+                 "LDR     R3, [SP]\n"
+                 "LDR     R1, [R3,#0x40]\n"
+                 "LDR     R2, [R3,#0x50]\n"
+                 "ADD     R0, R3, #4\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x4C]\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE2D18\n"
+                 "LDR     R3, [SP]\n"
+                 "ADD     R0, R3, #4\n"
+                 "LDR     R1, [R3,#0x40]\n"
+                 "LDR     R2, [R3,#0x58]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x54]\n"
+                 "B       loc_FFCE3D80\n"
+ "loc_FFCE3AD8:\n"
+                 "SUB     R3, R2, #0xE\n"
+                 "CMP     R3, #1\n"
+                 "BHI     loc_FFCE3B94\n"
+                 "ADD     R6, SP, #0xC\n"
+                 "ADD     R5, SP, #4\n"
+                 "MOV     R0, R12\n"
+                 "MOV     R1, R6\n"
+                 "MOV     R2, R5\n"
+                 "BL      sub_FFCE2D94\n"
+                 "MOV     R4, R0\n"
+                 "CMP     R4, #5\n"
+                 "CMPNE   R4, #1\n"
+                 "BNE     loc_FFCE3B2C\n"
+                 "LDR     R12, [SP]\n"
+                 "MOV     R0, R5\n"
+                 "LDR     R1, [R12,#0x40]\n"
+                 "MOV     R2, R4\n"
+                 "LDR     R3, [R12,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x4C]\n"
+                 "B       loc_FFCE3B64\n"
+ "loc_FFCE3B2C:\n"
+                 "CMP     R4, #6\n"
+                 "CMPNE   R4, #2\n"
+                 "BNE     loc_FFCE3B74\n"
+                 "LDR     R12, [SP]\n"
+                 "MOV     R0, R5\n"
+                 "MOV     R1, R8\n"
+                 "MOV     R2, R4\n"
+                 "LDR     R3, [R12,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x4C]\n"
+                 "MOV     R1, R6\n"
+                 "LDR     R0, [SP]\n"
+                 "MOV     R2, R5\n"
+                 "BL      sub_FFCE3740\n"
+ "loc_FFCE3B64:\n"
+                 "MOV     R1, R4\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE38E4\n"
+                 "B       loc_FFCE3D80\n"
+ "loc_FFCE3B74:\n"
+                 "LDR     R12, [SP]\n"
+                 "MOV     R2, R4\n"
+                 "ADD     R0, R12, #4\n"
+                 "LDR     R1, [R12,#0x40]\n"
+                 "LDR     R3, [R12,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x4C]\n"
+                 "B       loc_FFCE3D80\n"
+ "loc_FFCE3B94:\n"
+                 "SUB     R3, R2, #0x17\n"
+                 "CMP     R3, #1\n"
+                 "BHI     loc_FFCE3BEC\n"
+                 "LDR     R1, [R12,#0x40]\n"
+                 "ADD     R1, R1, R1,LSL#1\n"
+                 "ADD     R1, R12, R1,LSL#1\n"
+                 "ADD     R6, SP, #0xC\n"
+                 "SUB     R1, R1, #2\n"
+                 "MOV     R2, #6\n"
+                 "MOV     R0, R6\n"
+                 "BL      sub_FFEC3588\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE26C8\n"
+                 "LDR     R3, [SP]\n"
+                 "ADD     R0, R3, #4\n"
+                 "LDR     R1, [R3,#0x40]\n"
+                 "LDR     R2, [R3,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R3,#0x4C]\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE2898\n"
+                 "B       loc_FFCE3D80\n"
+ "loc_FFCE3BEC:\n"
+                 "ADD     R6, SP, #0xC\n"
+                 "ADD     R1, R12, #4\n"
+                 "MOV     R2, #6\n"
+                 "MOV     R0, R6\n"
+                 "BL      sub_FFEC3588\n"
+                 "LDR     R12, [SP]\n"
+                 "LDR     R3, [R12]\n"
+                 "MOV     R2, R12\n"
+                 "CMP     R3, #0x19\n"
+                 "LDRLS   PC, [PC,R3,LSL#2]\n"
+                 "B       loc_FFCE3D6C\n"
+                 ".long loc_FFCE3C80\n"
+                 ".long loc_FFCE3C8C\n"
+                 ".long loc_FFCE3C98\n"
+                 ".long loc_FFCE3C98\n"
+                 ".long loc_FFCE3C80\n"
+                 ".long loc_FFCE3C8C\n"
+                 ".long loc_FFCE3C98\n"
+                 ".long loc_FFCE3C98\n"
+                 ".long loc_FFCE3CBC\n"
+                 ".long loc_FFCE3CBC\n"
+                 ".long loc_FFCE3D40\n"
+                 ".long loc_FFCE3D4C\n"
+                 ".long loc_FFCE3D5C\n"
+                 ".long loc_FFCE3D6C\n"
+                 ".long loc_FFCE3D6C\n"
+                 ".long loc_FFCE3D6C\n"
+                 ".long loc_FFCE3CA4\n"
+                 ".long loc_FFCE3CB0\n"
+                 ".long loc_FFCE3CCC\n"
+                 ".long loc_FFCE3CD8\n"
+                 ".long loc_FFCE3D00\n"
+                 ".long loc_FFCE3D28\n"
+                 ".long loc_FFCE3D28\n"
+                 ".long loc_FFCE3D6C\n"
+                 ".long loc_FFCE3D6C\n"
+                 ".long loc_FFCE3D34\n"
+ "loc_FFCE3C80:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE1C68\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3C8C:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE1DA4\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3C98:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE1ED4\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3CA4:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE20A8\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3CB0:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE21B0\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3CBC:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE2274_my\n"   //------------->
+                 "MOV     R8, #0\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3CCC:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE2334\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3CD8:\n"
+                 "MOV     R0, R2\n"
+                 "LDRH    R2, [R2,#4]\n"
+                 "LDR     R3, =0x401A4\n"
+                 "STRH    R2, [SP,#0xC]\n"
+                 "LDRH    R1, [R3,#4]\n"
+                 "STRH    R1, [SP,#0x10]\n"
+                 "LDRH    R3, [R3,#2]\n"
+                 "STRH    R3, [SP,#0xE]\n"
+                 "BL      sub_FFCE24BC\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3D00:\n"
+                 "LDR     R3, =0x401A4\n"
+                 "LDRH    R1, [R3]\n"
+                 "STRH    R1, [SP,#0xC]\n"
+                 "MOV     R0, R2\n"
+                 "LDRH    R2, [R2,#6]\n"
+                 "STRH    R2, [SP,#0xE]\n"
+                 "LDRH    R3, [R3,#4]\n"
+                 "STRH    R3, [SP,#0x10]\n"
+                 "BL      sub_FFCE2550\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3D28:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE25D0\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3D34:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE2928\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3D40:\n"
+                 "MOV     R0, R2\n"
+                 "BL      sub_FFCE29FC\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3D4C:\n"
+                 "MOV     R0, R2\n"
+                 "MOV     R1, #0\n"
+                 "BL      sub_FFCE2AE8\n"
+                 "B       loc_FFCE3D68\n"
+ "loc_FFCE3D5C:\n"
+                 "MOV     R0, R2\n"
+                 "MOV     R1, #1\n"
+                 "BL      sub_FFCE2AE8\n"
+ "loc_FFCE3D68:\n"
+                 "LDR     R12, [SP]\n"
+ "loc_FFCE3D6C:\n"
+                 "ADD     R0, R12, #4\n"
+                 "LDR     R1, [R12,#0x40]\n"
+                 "LDR     R2, [R12,#0x50]\n"
+                 "MOV     LR, PC\n"
+                 "LDR     PC, [R12,#0x4C]\n"
+ "loc_FFCE3D80:\n"
+                 "CMP     R8, #1\n"
+                 "BNE     loc_FFCE3DA8\n"
+                 "LDR     R1, [SP]\n"
+                 "LDR     R3, [R1,#0x40]\n"
+                 "ADD     R3, R3, R3,LSL#1\n"
+                 "ADD     R1, R1, R3,LSL#1\n"
+                 "MOV     R0, R6\n"
+                 "SUB     R1, R1, #2\n"
+                 "BL      sub_FFCE1AD8\n"
+                 "B       loc_FFCE3DC8\n"
+ "loc_FFCE3DA8:\n"
+                 "MOV     R0, #1\n"
+                 "MOV     R1, R0\n"
+                 "MOV     R2, R0\n"
+                 "BL      sub_FFCE1A7C\n"
+                 "MOV     R0, #1\n"
+                 "MOV     R1, R0\n"
+                 "MOV     R2, R0\n"
+                 "BL      sub_FFCE1B94\n"
+ "loc_FFCE3DC8:\n"
+                 "LDR     R0, [SP]\n"
+                 "BL      sub_FFCE16C4\n"
+ "loc_FFCE3DD0:\n"
+                 "LDR     R3, =0x4019C\n"
+                 "MOV     R2, #0\n"
+                 "LDR     R0, [R3]\n"
+                 "MOV     R1, R7\n"
+                 "BL      sub_FFC100C0\n"
+                 "LDR     R12, [SP]\n"
+                 "LDR     R2, [R12]\n"
+                 "CMP     R2, #0x20\n"
+                 "BNE     loc_FFCE39E4\n"
+                 "MOV     R0, R12\n"
+                 "BL      sub_FFCE16C4\n"
+                 "LDR     R3, =0x40198\n"
+                 "MOV     R1, #1\n"
+                 "LDR     R0, [R3]\n"
+                 "BL      sub_FFC0F9A8\n"
+                 "BL      sub_FFC1161C\n"
+                 "ADD     SP, SP, #0x14\n"
+                 "LDMFD   SP!, {R4-R8,PC}\n"
+  );
+}
+
+
+void __attribute__((naked,noinline)) sub_FFCE2274_my(){
+ asm volatile(
+                 "STMFD   SP!, {R4,R5,LR}\n"
+                 "LDR     R3, =0x40198\n"
+                 "MOV     R4, R0\n"
+                 "MOV     R1, #0xE\n"
+                 "LDR     R0, [R3]\n"
+                 "BL      sub_FFC0FB44\n"
+                 "MOV     R1, #0\n"
+                 "LDRSH   R0, [R4,#4]\n"
+                 "BL      sub_FFCE17A0\n"
+                 "MOV     R5, R0\n"
+                 "LDRSH   R0, [R4,#6]\n"
+                 "BL      sub_FFCE1914\n"
+                 "LDRSH   R0, [R4,#8]\n"
+                 "BL      sub_FFCE19B0\n"
+                 "LDR     R3, [R4]\n"
+                 "CMP     R3, #9\n"
+                 "MOVEQ   R5, #0\n"
+                 "CMP     R5, #1\n"
+                 "LDR     R1, =0xFFCE16F8\n"
+                 "MOV     R2, #2\n"
+                 "BNE     loc_FFCE22E0\n"
+                 "LDRSH   R0, [R4,#4]\n"
+                 "BL      sub_FFE6D32C\n"
+                 "LDR     R2, =0x401C4\n"
+                 "MOV     R3, #0\n"
+                 "STR     R3, [R2]\n"
+                 "B       loc_FFCE22E4\n"
+ "loc_FFCE22E0:\n"
+                 "BL      sub_FFCE1A4C\n"
+ "loc_FFCE22E4:\n"
+                 "STRH    R0, [R4,#4]\n"
+                 "LDRSH   R0, [R4,#6]\n"
+                 "BL      sub_FFC974F0_my\n"  //------------>
+                 "LDRSH   R0, [R4,#8]\n"
+                 "MOV     R1, #1\n"
+                 "BL      sub_FFC99218\n"
+                 "MOV     R1, #0\n"
+                 "ADD     R0, R4, #8\n"
+                 "BL      sub_FFC992D8\n"
+                 "CMP     R5, #1\n"
+                 "MOV     R1, #2\n"
+                 "MOV     R2, #0\n"
+                 "LDMNEFD SP!, {R4,R5,PC}\n"
+                 "LDR     R3, =0x40198\n"
+                 "LDR     R0, [R3]\n"
+                 "LDMFD   SP!, {R4,R5,LR}\n"
+                 "B       sub_FFC0F998\n"
+ );
+}
+
+void __attribute__((naked,noinline)) sub_FFC974F0_my(){
+ asm volatile(
+                 "STMFD   SP!, {R4,LR}\n"
+                 "LDR     R3, =0x5334\n"
+                 "LDR     R2, [R3]\n"
+                 "MOV     R1, #0x114\n"
+                 "MOV     R3, R0,LSL#16\n"
+                 "CMP     R2, #1\n"
+                 "ADD     R1, R1, #1\n"
+                 "LDR     R0, =0xFFC96F6C\n"
+                 "MOV     R4, R3,ASR#16\n"
+                 "BEQ     loc_FFC9751C\n"
+                 "BL      sub_FFC03AE8\n"
+ "loc_FFC9751C:\n"
+                 "MOV     R1, #0x118\n"
+                 "CMN     R4, #0xC00\n"
+                 "LDR     R3, =0x32DAE\n"
+                 "LDR     R0, =0xFFC96F6C\n"
+                 "ADD     R1, R1, #3\n"
+                 "LDREQSH R4, [R3]\n"
+                 "LDRNE   R3, =0x32DAE\n"
+                 "CMN     R4, #0xC00\n"
+                 "STRH    R4, [R3]\n"
+                 "BNE     loc_FFC97548\n"
+                 "BL      sub_FFC03AE8\n"
+ "loc_FFC97548:\n"
+                 "MOV     R0, R4\n"
+                 "BL      ExpTimeInMicroseconds\n"
+                 "MOV     R4, R0\n"
+         //      "BL      nullsub_47\n"
+                 "MOV     R0, R4\n"
+                 "BL      sub_FFC96B24\n"
+                 "TST     R0, #1\n"
+                 "MOV     R1, #0x120\n"
+                 "LDR     R0, =0xFFC96F6C\n"
+                 "LDMEQFD SP!, {R4,PC}\n"
+                 "LDMFD   SP!, {R4,LR}\n"
+                 "B       sub_FFC03AE8\n"
+ );
+}
+
Index: platform/a530/sub/100a/stubs_entry_2.S
===================================================================
--- platform/a530/sub/100a/stubs_entry_2.S	(Revision 727)
+++ platform/a530/sub/100a/stubs_entry_2.S	(Arbeitskopie)
@@ -22,3 +22,4 @@
 NHSTUB(SetAE_ShutterSpeed, 0xFFE87778)
 NHSTUB(DoAFLock, 0xffd312e4)
 NHSTUB(UnlockAF, 0xffd31328)
+NHSTUB(ExpTimeInMicroseconds, 0xFFC985EC)
Index: platform/a530/sub/100a/makefile.inc.new
===================================================================
--- platform/a530/sub/100a/makefile.inc.new	(Revision 0)
+++ platform/a530/sub/100a/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a530/makefile.inc.new
===================================================================
--- platform/a530/makefile.inc.new	(Revision 0)
+++ platform/a530/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/a450/sub/100d/makefile.inc.new
===================================================================
--- platform/a450/sub/100d/makefile.inc.new	(Revision 0)
+++ platform/a450/sub/100d/makefile.inc.new	(Revision 0)
@@ -0,0 +1,11 @@
+
+
+ASM_OBJS:= stubs_min.o stubs_auto.o stubs_entry.o stubs_entry_2.o 
+C_OBJS:= boot.o capt_seq.o movie_rec.o lib.o
+
+
+STUBS_AUTO_DEPS:=boot.c capt_seq.c movie_rec.c
+
+
+include $(subdir)/../../../makefile_sub.inc.new
+# vim: ft=make
Index: platform/a450/makefile.inc.new
===================================================================
--- platform/a450/makefile.inc.new	(Revision 0)
+++ platform/a450/makefile.inc.new	(Revision 0)
@@ -0,0 +1,4 @@
+
+include $(TOPDIR)/platform/makefile_generic.inc.new
+
+# vim: ft=make
Index: platform/ixus950_sd850/main.c
===================================================================
--- platform/ixus950_sd850/main.c	(Revision 727)
+++ platform/ixus950_sd850/main.c	(Arbeitskopie)
@@ -25,13 +25,13 @@
 
 int get_focal_length(int zp) {
     if (zp<0) return fl_tbl[0];
-    else if (zp>NUM_FL-1) return fl_tbl[NUM_FL-1];
+    else if (zp>(int)NUM_FL-1) return fl_tbl[NUM_FL-1];
     else return fl_tbl[zp];
 }
 
 int get_zoom_x(int zp) {
     if (zp<1) return 10;
-    else if (zp>NUM_FL-1) return fl_tbl[NUM_FL-1]*10/fl_tbl[0];
+    else if (zp>(int)NUM_FL-1) return fl_tbl[NUM_FL-1]*10/fl_tbl[0];
     else return fl_tbl[zp]*10/fl_tbl[0];
 }
 
@@ -68,7 +68,8 @@
 #define MODESCNT (sizeof(modemap)/sizeof(modemap[0]))
 
 int mode_get() {
-    int mode, i, t=0xFF;
+    unsigned i;
+    int mode, t=0xFF;
 
     mode  = (physw_status[2] & 0x1000)?MODE_REC:MODE_PLAY;    
     _GetPropertyCase(49, &t, 4);
Index: platform/ixus950_sd850/sub/100c/capt_seq.c
===================================================================
--- platform/ixus950_sd850/sub/100c/capt_seq.c	(Revision 727)
+++ platform/ixus950_sd850/sub/100c/capt_seq.c	(Arbeitskopie)
@@ -1,6 +1,7 @@
 #include "lolevel.h"
 #include "platform.h"
 #include "core.h"
+#include "math.h"
 
 static long *nrflag = (long*)0xED44;
 
